/**************************************************************
	Inquire OSCTUNE value tool
	Copyrights(C)2008  air variable
	version 1.00
 **************************************************************
	author air_variable
	http://www.ne.jp/asahi/air/variable/
	version 1.01
	Tools:
	MPLAB v8.15a
	Hitech PIC C pro9.60pl4 build 3206
---------------------------------------------------------------
Date	:Time	Version	Build	Note
20081210:0735	1.00	---		begin the program
20081211:0845	1.01	---		16F87/88ɎΉvvZbTǉ
---------------------------------------------------------------
Project folder(default)
	C:\picsrc\piccpro\osctune
Source Files
	main.c (This file)
	lcd.c
Header Files
	lcd.h
---------------------------------------------------------------
for PIC16F88(87)
	Pin assignment
	1:RA2:O:LCD DB6
	2:RA3:O:LCD DB7
	3:RA4:I:GND
	4:MCLR:I:PICKIT2-1(W/10kPU)
	5:VSS:GND
	6:RB0:I:MODE SWITCH
	7:RB1:I:N.C.
	8:RB2:O:Monitor LED
	9:RB3:O:PWM out(Use negative potential)

	18:RA1:O:LCD DB5
	17:RA0:O:LCD DB4
	16:O:Buzzer out
	15:O:Fosc ckock out 2MHz
	14:VDD:Power 5 Volt
	13:RB7:O:LCD E
	12:RB6:O:LCD RS
	11:RB5:I:RIGHT SW
	10:RB4:I:LEFT SW

**************************************************************/

#include <pic.h>
#include "lcd.h"

#define MHz 000000
#define _XTAL_FREQ 8MHz
#define	TEST_TONE  	116
#define KEY_P		RB5 //
#define KEY_S		RB0 //
#define KEY_M		RB4 //
#define LED_OUT		RB2 //
#define BUZZ_OUT	RA7 //
#define EEP_ADR		0x00  // 0x00 to 0x7F

//see C:\Program Files\HI-TECH Software\PICC\PRO\9.60\include\pic16f87.h
__CONFIG(
	CCPRB3 & DEBUGDIS & LVPDIS & BOREN & MCLRDIS & PWRTEN & WDTDIS & INTCLK
	);
__CONFIG(
	FCMDIS & IESODIS
	);

unsigned char tone;

#pragma interrupt_level 1

//Timer Int process/
void interrupt isr( void )
{
    TMR0 = tone;
	if (tone != 0){
		if (BUZZ_OUT)
			BUZZ_OUT=0;
		else
			BUZZ_OUT=1;
	}
	TMR0IF =0;
}

void DelayMs(unsigned int temp){	//1ms multiple x times
	while(temp--){
		__delay_ms(1);
	}	
}

void lcd_puthex(unsigned char data){;
    //Send high nibble
    if( (data>>4) > 9 )
        lcd_putch( 'A' - 10 + (data>>4) );
    	else lcd_putch( '0' + (data>>4) );
    //Send low nibble
    if( (data&0x0F) > 9 )
        lcd_putch( 'A' - 10 + (data&0x0F) );
    	else lcd_putch( '0' + (data&0x0F) );
}

void lcd_valueout2d3(unsigned int temp){	//[TvXΉ _\[`
	if (temp<10000) {
		lcd_putch(' ');
	}else	lcd_putch(((temp /10000)%10)+0x30);//1000
	lcd_putch(((temp /1000)%10)+0x30);//1000
	lcd_putch('.');
	lcd_putch(((temp / 100)%10)+0x30);//100
	lcd_putch(((temp /  10)%10)+0x30);//10
	lcd_putch(((temp      )%10)+0x30);//1
	return;
}


main(){
//Initialization
	unsigned char data,pol;
	unsigned int data16;
//NbNݒ
	OSCCON = 0b01110000;	//8MHz,__configłFOSCݒ
		
//e|[g̏
//		  	  76543210
	PORTA = 0b00000000;		//|[gA
	PORTB = 0b00000000;		//|[gB
	TRISA = 0b00000000; 	//|[gA̕ݒ
	TRISB = 0b00110001; 	//|[gB̕ݒ

	T0CS =0; //use timer0
	PSA =0;	 //Prescale assigned timer 0
	PS2 =0; //prescale 1/16
	PS1 =1;
	PS0 =1;
#if defined(_16F88)	
	ANSEL = 0x00;			//Digital|[gŎgp
#endif
	CMCON = 0x07;			//|[gAfW^I/OƂĎgp
	RBPU  = 0;				//|[gBvAbvݒ
    TMR0	= 0x00 ;
	OSCTUNE =0; 			//default setting
    tone 	= TEST_TONE;	//Set Test tone(about 443Hz)
	PEIE	= 1;
	GIE		= 1;
	LED_OUT	= 0;

//PWM initialize setting (83.8KHz on RB3 @8MHz)
	CCP1CON = 0b00001100;// use PWM mode
	PR2 = 0x17; // resolution is 6.5bit mode
	CCPR1L = 0x0c; // duty is 50%
	T2CON = 0b00000100;	// POSTSCALE 1:1 ,TMR2 ON , PRESCALE 1:1

//lcd initialize
	DelayMs(250);
	lcd_init();
	lcd_clear();		//lcd clear
	lcd_write(0x0c);	//J[\\Ȃ
	OSCTUNE = EEPROM_READ(0x00);
	TMR0IE	= 1;
	while(1){
		if (!KEY_P) ++OSCTUNE & 0x3F;
		if (!KEY_M)	--OSCTUNE & 0x3F;
		if (!KEY_S) {
			TMR0IE	= 0;
			LED_OUT	=1;
			lcd_clear();
			lcd_goto(0x00);
			lcd_puts("EEPROM adr0x00");
			lcd_goto(0x40);
			lcd_puts("Data writing!");
			EEPROM_WRITE(EEP_ADR,OSCTUNE);
			DelayMs(1000);
			lcd_clear();
			LED_OUT=0;
			while (KEY_S==0);//key release check
			TMR0IE	= 1;
		}
		lcd_goto(0x00);
		lcd_puts("OSCTUNE=0x");
		lcd_puthex(OSCTUNE);

		data =OSCTUNE;

		if (data==0)	pol = ' ';
		else if (data < 0x20){
			pol = '+';
			data &= 0x1f;
		}else {
			pol = '-';
			data = 0x20-(data & 0x1f);
		}

		lcd_goto(0x40);
		lcd_puts("Ratio =");
		data16 = data * 391  ;//percent
		lcd_putch(pol);
		lcd_valueout2d3(data16);
		lcd_putch('%');
		DelayMs(100);
	}
}
